
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "xstd/Assert.h"
#include "base/Opt.h"


/* OptGrp */

void OptGrp::share(OptGrp *other) {
	Assert(other);
	for (int i = 0; i < theCount; ++i)
		other->append(item(i));
}


/* Opt */

Opt::Opt(OptGrp *aGrp, const char *aName, const char *aDescr):
	theGrp(aGrp), theCmdLine(0), theName(aName), theDescr(aDescr) {

	if (char *h = strchr(theName, ' ')) {
		theType = h+1;
		*h = '\0';
	} else {
		theType = "";
	}

	if (theGrp)
		theGrp->append(this); // self registration
}

Opt::~Opt() {
}
