
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "xstd/Clock.h"
#include "client/SyncClt.h"


void SyncClt::noteXactDone(CltXact *x) {
	Client::noteXactDone(x);
	if (theExtraLaunchLvl)
		--theExtraLaunchLvl;
	else
		scheduleLaunch(TheClock);
}

void SyncClt::wakeUp(const Alarm &a) {
	Client::wakeUp(a);
	tryLaunch(genXact());
}

void SyncClt::scheduleLaunch(Time) {
	Assert(!thePendAlarmCnt);
	Assert(!theThinkDistr);
	tryLaunch(genXact());
}

void SyncClt::launchFailed(CltXact *x) {
	Client::launchFailed(x);

	// if no alarms are pending, we may get stuck and submit
	// no more xactions; this is a kludge
	if (!thePendAlarmCnt && !theCcXactLvl)
		sleepTill(TheClock); // submit more next cycle
}
