
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "xstd/h/iostream.h"
#include "xstd/h/strstream.h"

#include "base/ObjId.h"
#include "csm/BodyIter.h"
#include "base/RndPermut.h"


BodyIter::BodyIter() {
	reset();
}

BodyIter::~BodyIter() {
	reset();
}

void BodyIter::configure(WrBuf *aBuf, Size aContSize) {
	Assert(theOid);
	theBuf = aBuf;
	theContSize = aContSize;
	theRng.seed(GlbPermut(theOid.hash(), rndBodyIter));
	theBuiltSize = 0;
}

void BodyIter::reset() {
	theOid.reset();
	theBuf = 0;
	theContSize = theBuiltSize = Size();
}
