
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_TEXT_DATABASE_H
#define PG_TEXT_DATABASE_H

#include "xstd/String.h"
#include "xstd/Array.h"

class ostream;

// a compact array of strings with pre-calculated lenghts

class TextDbase {
	public:
		TextDbase();
		~TextDbase();

		const String &name() const { return theName; }
		int count() const { return theStrs.count(); }
		int len(int pos) const { return theLens[pos]; }
		const char *str(int pos) const { return theStrs[pos]; }

		void name(const String &aName);

		void load(istream &is);

	protected:
		void add(const char *str, int len);

	protected:
		Array<char*> theStrs;
		Array<int> theLens;

		String theName;
};


#endif
