
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_DNS_RESOLVER_SYMBOL_H
#define PGL_DNS_RESOLVER_SYMBOL_H

#include "xstd/Time.h"
#include "xstd/Array.h"
#include "pgl/PglRecSym.h"

class NetAddr;

// parameters for object life cycle model
class DnsResolverSym: public RecSym {
	public:
		DnsResolverSym();
		DnsResolverSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		bool servers(Array<NetAddr*> &srvs) const;
		Time timeout() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
