
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "xstd/h/math.h"
#include "xstd/h/iostream.h"
#include "xstd/h/strstream.h"

#include "xstd/String.h"
#include "pgl/PglStringSym.h"
#include "pgl/PglArraySym.h"
#include "pgl/PglNetAddrRange.h"
#include "pgl/BenchSym.h"
#include "pgl/PolyMix3AsSym.h"


PolyMix3AsSym::PolyMix3AsSym(): VerThreeAsSym("PolyMix3As", new PglRec) {
	kind("PolyMix-3");
}

PolyMix3AsSym::PolyMix3AsSym(const String &aType, PglRec *aRec): VerThreeAsSym(aType, aRec) {
}

bool PolyMix3AsSym::isA(const String &type) const {
	return VerThreeAsSym::isA(type) || type == "PolyMix3As";
}

SynSym *PolyMix3AsSym::dupe(const String &type) const {
	if (isA(type))
		return new PolyMix3AsSym(this->type(), theRec->clone());
	return VerThreeAsSym::dupe(type);
}

String PolyMix3AsSym::robots(ArraySym *&addrs) const {
	return addresses(theBench->clientSide(), 0, addrs);
}

String PolyMix3AsSym::servers(ArraySym *&addrs) const {
	return addresses(theBench->serverSide(), 128, addrs);
}
