
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl/pgl.h"

#include "pgl/UniqIdSym.h"


UniqIdSym::UniqIdSym(const UniqId &aVal): ExpressionSym("uniq_id"), theVal(aVal) {
}

bool UniqIdSym::isA(const String &type) const {
	return ExpressionSym::isA(type) ||
		type == "UniqId" || type == "uniq_id";
}

SynSym *UniqIdSym::dupe(const String &type) const {
	if (isA(type))
		return new UniqIdSym(theVal);
	return ExpressionSym::dupe(type);
}

ostream &UniqIdSym::print(ostream &os, const String &) const {
	return os << theVal;
}
