
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_PROBE_AGENT_H
#define PG_PROBE_AGENT_H

#include "xstd/NetAddr.h"
#include "xstd/Socket.h"
#include "xstd/FileScanner.h"
#include "runtime/BcastRcver.h"

class ProbeXact;

class ProbeAgent: public FileScanner::User, public BcastRcver {
	public:
		ProbeAgent(const NetAddr &aLclHost, const NetAddr &aRmtHost);
		virtual ~ProbeAgent();

		const NetAddr &lclHost() const { return theLclHost; }
		const NetAddr &rmtHost() const { return theRmtHost; }

		virtual void exec() = 0;

		void noteXactDone(ProbeXact *x);

	protected:
		void setSockOpt(Socket &s);

		virtual void noteInfoEvent(BcastChannel *ch, InfoEvent ev);

	protected:
		NetAddr theLclHost;
		NetAddr theRmtHost;

		Socket theSock;
		FileScanReserv theReserv;
		bool isDone;
};

#endif
