
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_PROBE_OPTS_H
#define PG_PROBE_OPTS_H

#include "base/opts.h"
#include "base/polyOpts.h"

class ProbeOpts: public OptGrp {
	public:
		ProbeOpts();

		virtual bool validate() const;

		virtual ostream &printAnonym(ostream &os) const;
		virtual bool parseAnonym(const Array<const char *> &opts);
		virtual bool canParseAnonym() const { return true; }

	public:
		HelpOpt theHelpOpt;
		TimeOpt theDuration;
		TimeOpt theContTout;
		TimeOpt theStatExchTout;
		StrArrOpt theCltHosts;
		StrArrOpt theSrvHosts;
		StrOpt theConsFileName;
		FileScanOpt theFileScanner;
};

extern ProbeOpts TheProbeOpts;

#endif
