
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include "xstd/Clock.h"
#include "runtime/ErrorMgr.h"
#include "runtime/IcpXaction.h"

#include "runtime/polyBcastChannels.h"
#include "runtime/polyErrors.h"
#include "base/polyLogCats.h"


void IcpXaction::reset() {
	theAddr = NetAddr();
	theOid.reset();
	theStartTime = theLifeTime = Time();
	theRepSize = Size();
	theResult = icpInvalid;
	theLogCat = lgcAll;
}

void IcpXaction::start() {
	theStartTime = TheClock;
}

void IcpXaction::finish(Error err) {
	theLifeTime = TheClock - theStartTime;

	if (err) {
		theResult = icpInvalid;
		if (err != errOther)
			ReportError(err);
	} else {
		Broadcast(TheIcpXactEndChannel, this);
	}
}
