
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef XPARSER_GLEXER_H
#define XPARSER_GLEXER_H

#include "xparser/Lexer.h"

class istream;
struct FinalInfo;

// The GLexer class is the base class from which generated lexer classes
// are derived from.

class GLexer: public Lexer {
	public:
		GLexer(istream &aSource, const String &aFname);
		virtual ~GLexer();

		const String &fname() const { return theFName; }
		istream &source() { return theSource; }

	protected:
		virtual LexToken scan();
		void nextCh();

		virtual int transition(int, int) = 0;
	
	protected:
		istream &theSource;
		String theFName;

		int initialState;
		FinalInfo *finalInfo;

		LexTokenChar _lookahead;
};


// The FinalInfo class provides information about final states of a
// generated FSA.

typedef void (*filterProc)(GLexer *, LexToken &);
struct FinalInfo {
	int tokenValue;
	filterProc filter;
};

#endif
